(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('database-builder'), require('rxjs/operators'), require('moment')) :
    typeof define === 'function' && define.amd ? define('ionic-database-builder', ['exports', '@angular/core', 'rxjs', 'database-builder', 'rxjs/operators', 'moment'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ionic-database-builder"] = {}, global.ng.core, global.rxjs, global.databaseBuilder, global.rxjs.operators, global.momentNs));
})(this, (function (exports, core, rxjs, databaseBuilder, operators, momentNs) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var momentNs__namespace = /*#__PURE__*/_interopNamespace(momentNs);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var DatabaseFactoryContract = /** @class */ (function () {
        function DatabaseFactoryContract() {
        }
        return DatabaseFactoryContract;
    }());

    var IS_AVAILABLE_DATABASE = new core.InjectionToken('is_available');
    var IS_ENABLE_LOG = new core.InjectionToken('is_enable_log');
    var DATABASE_CREATOR = new core.InjectionToken('database_creator');
    var DATABASE_MIGRATION = new core.InjectionToken('database_migration');
    var PLATFORM_LOAD = new core.InjectionToken('platform_load');

    var DatabaseFactoryDefault = /** @class */ (function (_super) {
        __extends(DatabaseFactoryDefault, _super);
        function DatabaseFactoryDefault(_isAvailable, _databaseCreator) {
            var _this = _super.call(this) || this;
            _this._isAvailable = _isAvailable;
            _this._databaseCreator = _databaseCreator;
            return _this;
        }
        DatabaseFactoryDefault.prototype.database = function (databaseName) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                if (_this._isAvailable) {
                    _this._databaseCreator.create({
                        name: databaseName,
                        location: 'default'
                    })
                        .then(function (database) {
                        observer.next(database);
                        observer.complete();
                    })
                        .catch(function (err) {
                        observer.error(err);
                        observer.complete();
                    });
                }
                else {
                    observer.next(void 0);
                    observer.complete();
                }
            });
        };
        return DatabaseFactoryDefault;
    }(DatabaseFactoryContract));
    DatabaseFactoryDefault.decorators = [
        { type: core.Injectable }
    ];
    DatabaseFactoryDefault.ctorParameters = function () { return [
        { type: Boolean, decorators: [{ type: core.Inject, args: [IS_AVAILABLE_DATABASE,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [DATABASE_CREATOR,] }] }
    ]; };

    var DatabaseManager = /** @class */ (function () {
        function DatabaseManager(databaseFactory, _platformLoad) {
            this.databaseFactory = databaseFactory;
            this._platformLoad = _platformLoad;
            this._databases = new Map();
        }
        DatabaseManager.prototype.cleanDatabaseName = function (name) {
            return name.replace(/([^a-z0-9]+)/gi, '-');
        };
        DatabaseManager.prototype.addDatabaseNameExtension = function (databaseName) {
            return databaseName + ".db";
        };
        DatabaseManager.prototype.databaseInstance = function (name, version) {
            var keyDatabaseName = name + version;
            return this._databases.has(keyDatabaseName)
                ? this._databases.get(keyDatabaseName)
                : this.setDatabase(keyDatabaseName, this.createDatabase(this.databaseNameFile(name), version));
        };
        DatabaseManager.prototype.invalidateInstance = function () {
            this._databases = new Map();
        };
        DatabaseManager.prototype.setDatabase = function (keyDatabaseName, promiseDatabase) {
            if (promiseDatabase) {
                return this._databases
                    .set(keyDatabaseName, promiseDatabase)
                    .get(keyDatabaseName);
            }
            throw new databaseBuilder.DatabaseBuilderError("Connection with provider of database cannot be created!");
        };
        DatabaseManager.prototype.createDatabase = function (name, version) {
            var _this = this;
            return new Promise(function (resolve, reject) {
                _this._platformLoad.ready()
                    .then(function () {
                    _this.databaseFactory.database(name)
                        .subscribe(function (database) {
                        _this.migrationVersion(database, version)
                            .subscribe(function (_) {
                            resolve(database);
                        }, function (err) {
                            reject(err);
                        });
                    }, function (err) {
                        _this.catchException(err);
                        reject(err);
                    });
                })
                    .catch(function (err) {
                    _this.catchException(err);
                    reject(err);
                });
            });
        };
        DatabaseManager.prototype.catchException = function (e) {
            // tslint:disable-next-line:no-console
            console.error(e);
        };
        return DatabaseManager;
    }());

    var BuildableDatabaseManager = /** @class */ (function (_super) {
        __extends(BuildableDatabaseManager, _super);
        function BuildableDatabaseManager(databaseFactory, _databaseSettings, _injector, _mapper, platformLoad, enableLog) {
            if (enableLog === void 0) { enableLog = true; }
            var _this = _super.call(this, databaseFactory, platformLoad) || this;
            _this._databaseSettings = _databaseSettings;
            _this._injector = _injector;
            _this._mapper = _mapper;
            _this.enableLog = enableLog;
            return _this;
        }
        Object.defineProperty(BuildableDatabaseManager.prototype, "mapper", {
            get: function () {
                return this._mapper;
            },
            enumerable: false,
            configurable: true
        });
        BuildableDatabaseManager.prototype.databaseInstance = function () {
            var database = _super.prototype.databaseInstance.call(this, this.databaseName(), this.version());
            if (!database) {
                throw new Error('SQLite not avaliable!');
            }
            return database;
        };
        BuildableDatabaseManager.prototype.managedTransaction = function () {
            return rxjs.from(this.databaseInstance()).pipe(operators.mergeMap(function (database) {
                if (!database.managedTransaction) {
                    throw new databaseBuilder.DatabaseBuilderError('Managed Transaction not supported in current middleware!');
                }
                return rxjs.of(database.managedTransaction());
            }));
        };
        // /**
        //  * @deprecated Use managedTransaction()
        //  */
        // public newTransaction(successTransaction: () => void): Observable<DatabaseBaseTransaction> {
        //     return new Observable((observer: Observer<DatabaseBaseTransaction>) => {
        //         this.databaseInstance()
        //             .then(database => {
        //                 database.transaction((result: DatabaseBaseTransaction) => {
        //                     observer.next(result);
        //                     observer.complete();
        //                 })
        //                     .then(x => {
        //                         successTransaction();
        //                     })
        //                     .catch(error => {
        //                         observer.error(error);
        //                         observer.complete();
        //                     });
        //             })
        //             .catch(err => {
        //                 observer.error(err);
        //                 observer.complete();
        //             });
        //     });
        // }
        // /**
        //  * @deprecated Use managedTransaction()
        //  */
        // public transaction(successTransaction: () => void): Observable<Crud> {
        //     return new Observable((observer: Observer<Crud>) => {
        //         this.newTransaction(successTransaction)
        //             .subscribe((transaction) => {
        //                 observer.next(new Crud({ database: transaction, getMapper: this._mapper, enableLog: this.enableLog }));
        //                 observer.complete();
        //             }, error => {
        //                 observer.error(error);
        //                 observer.complete();
        //             });
        //     });
        // }
        /**
         * @deprecated Use managedTransaction()
         */
        BuildableDatabaseManager.prototype.beginTransaction = function () {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.sql('BEGIN TRANSACTION')
                    .subscribe(function (r) {
                    _this.crud()
                        .subscribe(function (crud) {
                        observer.next(crud);
                        observer.complete();
                    }, function (error) {
                        observer.error(error);
                        observer.complete();
                    });
                }, function (error) {
                    observer.error(error);
                    observer.complete();
                });
            });
        };
        /**
         * @deprecated Use managedTransaction()
         */
        BuildableDatabaseManager.prototype.commitTransaction = function () {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.sql('COMMIT')
                    .subscribe(function (r) {
                    observer.next(true);
                    observer.complete();
                }, function (error) {
                    observer.error(error);
                    observer.complete();
                });
            });
        };
        /**
         * @deprecated Use managedTransaction()
         */
        BuildableDatabaseManager.prototype.rollbackTransaction = function () {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.sql('ROLLBACK')
                    .subscribe(function (r) {
                    observer.next(true);
                    observer.complete();
                }, function (error) {
                    observer.error(error);
                    observer.complete();
                });
            });
        };
        BuildableDatabaseManager.prototype.crud = function () {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.databaseInstance()
                    .then(function (database) { return __awaiter(_this, void 0, void 0, function () {
                    var _a, _b, _c;
                    return __generator(this, function (_d) {
                        switch (_d.label) {
                            case 0:
                                _b = (_a = observer).next;
                                _c = databaseBuilder.Crud.bind;
                                return [4 /*yield*/, this._databaseSettings.config(this._injector, database)];
                            case 1:
                                _b.apply(_a, [new (_c.apply(databaseBuilder.Crud, [void 0, _d.sent(), { database: database, getMapper: this._mapper, enableLog: this.enableLog }]))()]);
                                observer.complete();
                                return [2 /*return*/];
                        }
                    });
                }); })
                    .catch(function (error) { observer.error(error); observer.complete(); });
            });
        };
        BuildableDatabaseManager.prototype.sql = function (sql, params) {
            var _this = this;
            if (params === void 0) { params = []; }
            return new rxjs.Observable(function (observer) {
                _this.databaseInstance()
                    .then(function (database) {
                    var executable = new databaseBuilder.ExecutableBuilder(_this.enableLog);
                    executable.execute([{
                            query: sql,
                            params: params
                        }], database)
                        .subscribe(function (cursor) {
                        observer.next(cursor[0]);
                        observer.complete();
                    }, function (err) {
                        observer.error(err);
                        observer.complete();
                    });
                })
                    .catch(function (err) {
                    observer.error(err);
                    observer.complete();
                });
            });
        };
        BuildableDatabaseManager.prototype.query = function (typeT, alias) {
            var _this = this;
            if (alias === void 0) { alias = void 0; }
            return new rxjs.Observable(function (observer) {
                _this.databaseInstance()
                    .then(function (database) {
                    var that = _this;
                    observer.next(new databaseBuilder.Query(typeT, {
                        alias: alias,
                        getMapper: function (tKey) {
                            return that._mapper.get(tKey);
                        },
                        mapperTable: _this._mapper.get(typeT).mapperTable,
                        database: database,
                        enableLog: _this.enableLog
                    }));
                    observer.complete();
                })
                    .catch(function (error) {
                    observer.error(error);
                    observer.complete();
                });
            });
        };
        BuildableDatabaseManager.prototype.ddl = function () {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.databaseInstance()
                    .then(function (database) {
                    observer.next(new databaseBuilder.Ddl({ database: database, getMapper: _this._mapper, enableLog: _this.enableLog }));
                    observer.complete();
                })
                    .catch(function (error) {
                    observer.error(error);
                    observer.complete();
                });
            });
        };
        return BuildableDatabaseManager;
    }(DatabaseManager));

    var moment = momentNs__namespace;
    var DatabaseMigrationBase = /** @class */ (function () {
        function DatabaseMigrationBase() {
        }
        DatabaseMigrationBase.prototype.version = function (database, version) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.checkTableVersion(database)
                    .subscribe(function (_) {
                    _this.checkVersion(database, version)
                        .subscribe(function (result) {
                        _this.migration(database, result)
                            .subscribe(function (r) {
                            observer.next(r);
                            observer.complete();
                        }, function (err) { return _this.error(err, observer); });
                    }, function (err) { return _this.error(err, observer); });
                }, function (err) { return _this.error(err, observer); });
            });
        };
        DatabaseMigrationBase.prototype.error = function (error, observer) {
            // tslint:disable-next-line:no-console
            console.error(error);
            observer.error(error);
            observer.complete();
        };
        DatabaseMigrationBase.prototype.checkTableVersion = function (database) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                // return new Promise<any>((resolve, reject) => {
                var scriptTableVersion = "CREATE TABLE IF NOT EXISTS MigrationVersion(\n                    id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT\n                    , data INTEGER\n                    , version TEXT\n                    );";
                database.executeSql(scriptTableVersion, {})
                    .then(function (result) {
                    observer.next(result);
                    observer.complete();
                }, function (err) { return _this.error(err, observer); });
            });
        };
        DatabaseMigrationBase.prototype.checkVersion = function (database, newVersion) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.getVersion(database).subscribe(function (oldVersion) {
                    if (oldVersion > 0) {
                        if (newVersion > oldVersion) {
                            // tslint:disable-next-line:no-console
                            console.info("Version old: " + oldVersion);
                            database.executeSql("UPDATE MigrationVersion\n                                SET (data, version) = (?, ?);", [moment().unix(), newVersion])
                                .then()
                                .catch(function (err) { return _this.error(err, observer); });
                        }
                    }
                    else {
                        database.executeSql("INSERT INTO MigrationVersion (data, version) VALUES (?, ?)", [moment().unix(), newVersion])
                            .then()
                            .catch(function (err) { return _this.error(err, observer); });
                    }
                    observer.next({
                        oldVersion: oldVersion,
                        newVersion: newVersion
                    });
                    observer.complete();
                });
            });
        };
        DatabaseMigrationBase.prototype.getVersion = function (database) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                database.executeSql("SELECT * FROM MigrationVersion", {})
                    .then(function (result) {
                    var version = 0;
                    if (result.rows.length > 0) {
                        version = Number.parseFloat(result.rows.item(0).version);
                    }
                    observer.next(version);
                    observer.complete();
                })
                    .catch(function (err) { return _this.error(err, observer); });
            });
        };
        DatabaseMigrationBase.prototype.migration = function (database, control) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                _this.migrationExecute(database, control)
                    .subscribe(function (result) {
                    observer.next(result);
                    observer.complete();
                }, function (err) { return _this.error(err, observer); });
            });
        };
        return DatabaseMigrationBase;
    }());

    var DatabaseSettingsFactoryContract = /** @class */ (function () {
        function DatabaseSettingsFactoryContract() {
        }
        return DatabaseSettingsFactoryContract;
    }());

    var PlatformLoad = /** @class */ (function () {
        function PlatformLoad() {
        }
        return PlatformLoad;
    }());

    var PlatformLoadDefault = /** @class */ (function (_super) {
        __extends(PlatformLoadDefault, _super);
        function PlatformLoadDefault() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        PlatformLoadDefault.prototype.ready = function () {
            return Promise.resolve();
        };
        return PlatformLoadDefault;
    }(PlatformLoad));
    PlatformLoadDefault.decorators = [
        { type: core.Injectable }
    ];

    var DatabaseSettingsFactoryDefault = /** @class */ (function (_super) {
        __extends(DatabaseSettingsFactoryDefault, _super);
        function DatabaseSettingsFactoryDefault(versionOrModel, databaseName, mapper) {
            var _this = _super.call(this) || this;
            if (Number.isInteger(versionOrModel)) {
                _this._model = {
                    version: versionOrModel,
                    databaseName: databaseName,
                    mapper: mapper
                };
            }
            else {
                _this._model = versionOrModel;
            }
            return _this;
        }
        DatabaseSettingsFactoryDefault.prototype.databaseName = function (injector) {
            return this._model.databaseName;
        };
        DatabaseSettingsFactoryDefault.prototype.version = function (injector) {
            return this._model.version;
        };
        DatabaseSettingsFactoryDefault.prototype.mapper = function () {
            return this._model.mapper;
        };
        DatabaseSettingsFactoryDefault.prototype.config = function (injector, database) {
            return Promise.resolve({
                sqliteLimitVariables: 999
            });
        };
        return DatabaseSettingsFactoryDefault;
    }(DatabaseSettingsFactoryContract));

    var DatabaseHelperService = /** @class */ (function (_super) {
        __extends(DatabaseHelperService, _super);
        function DatabaseHelperService() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return DatabaseHelperService;
    }(databaseBuilder.DatabaseHelper));
    DatabaseHelperService.decorators = [
        { type: core.Injectable }
    ];

    var DatabaseMigrationContract = /** @class */ (function () {
        function DatabaseMigrationContract() {
        }
        DatabaseMigrationContract.prototype.onStart = function () {
        };
        DatabaseMigrationContract.prototype.onFinish = function () {
        };
        DatabaseMigrationContract.prototype.onProgress = function () {
        };
        return DatabaseMigrationContract;
    }());

    var DatabaseMigration = /** @class */ (function (_super) {
        __extends(DatabaseMigration, _super);
        function DatabaseMigration(_injector, _databaseMigrationContract) {
            var _this = _super.call(this) || this;
            _this._injector = _injector;
            _this._databaseMigrationContract = _databaseMigrationContract;
            // tslint:disable-next-line: deprecation
            _this._settings = _injector.get(DatabaseSettingsFactoryContract);
            return _this;
        }
        DatabaseMigration.prototype.reset = function (database) {
            // tslint:disable-next-line:no-console
            console.info('database reset');
            var observablesWait = [];
            var mappers = this._settings.mapper(this._injector);
            // remove dados offline da versão anterior, pois o formato dos dados foi alterado de uma versão para a outra
            var ddl = new databaseBuilder.Ddl({ database: database, getMapper: mappers, enableLog: true });
            mappers.forEachMapper(function (value, key) {
                if (!value.readOnly) {
                    observablesWait.push(ddl.drop(value.newable).execute());
                    observablesWait.push(ddl.create(value.newable).execute());
                }
            });
            return databaseBuilder.forkJoinSafe(observablesWait);
        };
        DatabaseMigration.prototype.migrationExecute = function (database, version) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                var observablesNested = [];
                if (_this._databaseMigrationContract) {
                    _this._databaseMigrationContract.onStart();
                    var toObservables = _this._databaseMigrationContract.to(version, database, _this._settings.mapper(_this._injector), _this);
                    if (toObservables && toObservables.length > 0) {
                        observablesNested = observablesNested.concat(toObservables);
                    }
                }
                if (observablesNested.length === 0 && version.oldVersion < 1) {
                    observablesNested.push(_this.reset(database));
                }
                if (observablesNested.length > 0) {
                    _this._databaseMigrationContract.onProgress();
                }
                _this.callNested(observablesNested, 0)
                    .subscribe(function (result) {
                    observer.next(result);
                    observer.complete();
                }, function (error) {
                    observer.error(error);
                    observer.complete();
                }, function () {
                    _this._databaseMigrationContract.onFinish();
                });
            });
        };
        DatabaseMigration.prototype.callNested = function (observablesNested, nextIndex) {
            var _this = this;
            return new rxjs.Observable(function (observer) {
                if (observablesNested.length > nextIndex) {
                    observablesNested[nextIndex].subscribe(function (result) {
                        _this.callNested(observablesNested, ++nextIndex).subscribe(function (_) {
                            observer.next(true);
                            observer.complete();
                        }, function (error) {
                            observer.error(error);
                            observer.complete();
                        });
                    });
                }
                else {
                    observer.next(true);
                    observer.complete();
                }
            });
        };
        return DatabaseMigration;
    }(DatabaseMigrationBase));
    DatabaseMigration.decorators = [
        { type: core.Injectable }
    ];
    DatabaseMigration.ctorParameters = function () { return [
        { type: core.Injector },
        { type: DatabaseMigrationContract, decorators: [{ type: core.Optional }, { type: core.Inject, args: [DATABASE_MIGRATION,] }] }
    ]; };

    var DatabaseMockService = /** @class */ (function () {
        function DatabaseMockService() {
        }
        DatabaseMockService.prototype.create = function (config) {
            var _this = this;
            console.log('Database Fake! \\o/');
            return new Promise(function (resolve, reject) {
                resolve({
                    executeSql: function (statement, params) {
                        _this.executeFake(statement, params);
                        return new Promise(function (executeSqlResolve, executeSqlReject) {
                            executeSqlResolve(_this.resultFake());
                        });
                    },
                    transaction: function (fn) {
                        return new Promise(function (executeSqlResolve, executeSqlReject) {
                            fn({
                                executeSql: function (sql, values, success, error) {
                                    _this.executeFake(sql, values);
                                    success(void 0, _this.resultFake());
                                },
                            });
                            executeSqlResolve(void 0);
                        });
                    }
                });
            });
        };
        DatabaseMockService.prototype.executeFake = function (sql, params) {
            console.log("Fake - sql: " + sql + ", params: " + JSON.stringify(params));
        };
        DatabaseMockService.prototype.resultFake = function () {
            return {
                rows: {
                    length: 20,
                    item: function (index) {
                        return {
                            index: index
                        };
                    }
                }
            };
        };
        return DatabaseMockService;
    }());
    DatabaseMockService.decorators = [
        { type: core.Injectable }
    ];

    var Database = /** @class */ (function (_super) {
        __extends(Database, _super);
        function Database(_isAvailable, isEnableLog, databaseSettings, injector, databaseFactory, _databaseMigration, platformLoad) {
            var _this = _super.call(this, databaseFactory, databaseSettings, injector, databaseSettings.mapper(injector), platformLoad, isEnableLog) || this;
            _this._isAvailable = _isAvailable;
            _this._databaseMigration = _databaseMigration;
            return _this;
        }
        Database.prototype.migrationVersion = function (database, version) {
            if (this._isAvailable) {
                return this._databaseMigration.version(database, version);
            }
            return new rxjs.Observable(function (observer) {
                observer.next(true);
                observer.complete();
            });
        };
        Database.prototype.databaseName = function () {
            return this._databaseSettings.databaseName(this._injector);
        };
        Database.prototype.version = function () {
            return this._databaseSettings.version(this._injector);
        };
        Database.prototype.databaseNameFile = function (databaseName) {
            if (databaseName === void 0) { databaseName = this.databaseName(); }
            return this.addDatabaseNameExtension(this.cleanDatabaseName(databaseName));
        };
        return Database;
    }(BuildableDatabaseManager));
    Database.decorators = [
        { type: core.Injectable }
    ];
    Database.ctorParameters = function () { return [
        { type: Boolean, decorators: [{ type: core.Inject, args: [IS_AVAILABLE_DATABASE,] }] },
        { type: Boolean, decorators: [{ type: core.Inject, args: [IS_ENABLE_LOG,] }] },
        { type: DatabaseSettingsFactoryContract },
        { type: core.Injector },
        { type: DatabaseFactoryContract },
        { type: DatabaseMigration },
        { type: PlatformLoad, decorators: [{ type: core.Inject, args: [PLATFORM_LOAD,] }] }
    ]; };

    var WebSqlDatabaseService = /** @class */ (function (_super) {
        __extends(WebSqlDatabaseService, _super);
        function WebSqlDatabaseService() {
            return _super.call(this, window) || this;
        }
        return WebSqlDatabaseService;
    }(databaseBuilder.WebSqlDatabaseAdapter));
    WebSqlDatabaseService.decorators = [
        { type: core.Injectable }
    ];
    WebSqlDatabaseService.ctorParameters = function () { return []; };

    var IonicDatabaseBuilderModule = /** @class */ (function () {
        function IonicDatabaseBuilderModule(parentModule) {
            if (parentModule) {
                throw new Error('IonicDatabaseBuilderModule is already loaded. Import it in the AppModule only');
            }
        }
        IonicDatabaseBuilderModule.forSimple = function (isEnableLogProvider, isAvailableProvider, platformLoad) {
            if (isEnableLogProvider === void 0) { isEnableLogProvider = false; }
            if (isAvailableProvider === void 0) { isAvailableProvider = true; }
            if (platformLoad === void 0) { platformLoad = PlatformLoadDefault; }
            return {
                ngModule: IonicDatabaseBuilderModule,
                providers: [
                    { provide: IS_ENABLE_LOG, useValue: isEnableLogProvider },
                    { provide: IS_AVAILABLE_DATABASE, useValue: isAvailableProvider },
                    { provide: PLATFORM_LOAD, useClass: platformLoad },
                ]
            };
        };
        IonicDatabaseBuilderModule.forRoot = function (settingsProvider, databaseCreatorProvider, databaseMigrationContract, platformLoad, isEnableLogProvider, isAvailableProvider) {
            if (platformLoad === void 0) { platformLoad = PlatformLoadDefault; }
            if (isEnableLogProvider === void 0) { isEnableLogProvider = false; }
            if (isAvailableProvider === void 0) { isAvailableProvider = true; }
            return {
                ngModule: IonicDatabaseBuilderModule,
                providers: [
                    { provide: DatabaseSettingsFactoryContract, useClass: settingsProvider },
                    { provide: DATABASE_CREATOR, useClass: databaseCreatorProvider },
                    { provide: DATABASE_MIGRATION, useClass: databaseMigrationContract },
                    { provide: IS_ENABLE_LOG, useValue: isEnableLogProvider },
                    { provide: PLATFORM_LOAD, useClass: platformLoad },
                    { provide: IS_AVAILABLE_DATABASE, useValue: isAvailableProvider },
                ]
            };
        };
        return IonicDatabaseBuilderModule;
    }());
    IonicDatabaseBuilderModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [
                        DatabaseMigration,
                        Database,
                        DatabaseHelperService,
                        {
                            provide: DatabaseFactoryContract,
                            useClass: DatabaseFactoryDefault
                        },
                        {
                            provide: PLATFORM_LOAD,
                            useClass: PlatformLoadDefault
                        }
                    ]
                },] }
    ];
    IonicDatabaseBuilderModule.ctorParameters = function () { return [
        { type: IonicDatabaseBuilderModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
    ]; };

    /*
     * Public API Surface of ionic-database-builder
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BuildableDatabaseManager = BuildableDatabaseManager;
    exports.DATABASE_CREATOR = DATABASE_CREATOR;
    exports.DATABASE_MIGRATION = DATABASE_MIGRATION;
    exports.Database = Database;
    exports.DatabaseFactoryContract = DatabaseFactoryContract;
    exports.DatabaseFactoryDefault = DatabaseFactoryDefault;
    exports.DatabaseHelperService = DatabaseHelperService;
    exports.DatabaseManager = DatabaseManager;
    exports.DatabaseMigration = DatabaseMigration;
    exports.DatabaseMigrationBase = DatabaseMigrationBase;
    exports.DatabaseMigrationContract = DatabaseMigrationContract;
    exports.DatabaseMockService = DatabaseMockService;
    exports.DatabaseSettingsFactoryContract = DatabaseSettingsFactoryContract;
    exports.DatabaseSettingsFactoryDefault = DatabaseSettingsFactoryDefault;
    exports.IS_AVAILABLE_DATABASE = IS_AVAILABLE_DATABASE;
    exports.IS_ENABLE_LOG = IS_ENABLE_LOG;
    exports.IonicDatabaseBuilderModule = IonicDatabaseBuilderModule;
    exports.PLATFORM_LOAD = PLATFORM_LOAD;
    exports.PlatformLoad = PlatformLoad;
    exports.PlatformLoadDefault = PlatformLoadDefault;
    exports.WebSqlDatabaseService = WebSqlDatabaseService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ionic-database-builder.umd.js.map
