import { DatabaseFactoryContract } from '../utils/database-factory-contract';
import { DatabaseObject, DatabaseCreatorContract } from 'database-builder';
import { Observable } from 'rxjs';
export declare class DatabaseFactoryDefault extends DatabaseFactoryContract {
    private _isAvailable;
    private _databaseCreator;
    constructor(_isAvailable: boolean, _databaseCreator: DatabaseCreatorContract);
    database(databaseName: string): Observable<DatabaseObject>;
}
