import { DatabaseObject, GetMapper } from 'database-builder';
import { Injector } from '@angular/core';
import { DatabaseSettingsModel } from '../model/database-settings-model';
import { DatabaseSettingsFactoryContract } from '../utils';
import { ConfigDatabase } from 'database-builder/src/crud/config-database';
export declare class DatabaseSettingsFactoryDefault extends DatabaseSettingsFactoryContract {
    private _model;
    constructor(versionOrModel: number | DatabaseSettingsModel, databaseName: string, mapper: GetMapper);
    databaseName(injector: Injector): string;
    version(injector: Injector): number;
    mapper(): GetMapper;
    config(injector: Injector, database: DatabaseObject): Promise<ConfigDatabase>;
}
