import { DatabaseCreatorContract } from 'database-builder';
import { Type, ModuleWithProviders } from '@angular/core';
import { DatabaseMigrationContract } from './services/database-migration-contract';
import { DatabaseSettingsFactoryContract } from './utils/database-settings-factory-contract';
import { PlatformLoad } from './utils/platform-load';
export declare class IonicDatabaseBuilderModule {
    constructor(parentModule: IonicDatabaseBuilderModule);
    static forSimple(isEnableLogProvider?: boolean, isAvailableProvider?: boolean, platformLoad?: Type<PlatformLoad>): ModuleWithProviders<IonicDatabaseBuilderModule>;
    static forRoot(settingsProvider: Type<DatabaseSettingsFactoryContract>, databaseCreatorProvider: Type<DatabaseCreatorContract>, databaseMigrationContract: Type<DatabaseMigrationContract>, platformLoad?: Type<PlatformLoad>, isEnableLogProvider?: boolean, isAvailableProvider?: boolean): ModuleWithProviders<IonicDatabaseBuilderModule>;
}
