import { Version } from './../model/version-model';
import { Injector } from '@angular/core';
import { DatabaseObject } from 'database-builder';
import { DatabaseMigrationContract } from './database-migration-contract';
import { DatabaseMigrationBase } from '../utils/database-migration-base';
import { DatabaseResettableContract } from './database-resettable-contract';
import { Observable } from 'rxjs';
export declare class DatabaseMigration extends DatabaseMigrationBase implements DatabaseResettableContract {
    private _injector;
    private _databaseMigrationContract;
    private _settings;
    constructor(_injector: Injector, _databaseMigrationContract: DatabaseMigrationContract);
    reset(database: DatabaseObject): Observable<any>;
    protected migrationExecute(database: DatabaseObject, version: Version): Observable<boolean>;
    private callNested;
}
