import { Injector } from '@angular/core';
import { DatabaseObject, GetMapper } from 'database-builder';
import { ConfigDatabase } from 'database-builder/src/crud/config-database';
export declare abstract class DatabaseSettingsFactoryContract {
    abstract databaseName(injector: Injector): string;
    abstract version(injector: Injector): number;
    abstract mapper(injector: Injector): GetMapper;
    abstract config(injector: Injector, database: DatabaseObject): Promise<ConfigDatabase>;
}
